[LeetCode]Longest Increasing Subsequence

Given an unsorted array of integers, find the length of longest increasing subsequence.

For example,
Given [10, 9, 2, 5, 3, 7, 101, 18],
The longest increasing subsequence is [2, 3, 7, 101], therefore the length is 4. Note that there may be more than one LIS combination, it is only necessary for you to return the length.

Your algorithm should run in O(n2) complexity.

Follow up: Could you improve it to O(n log n) time complexity?

题解:动态规划题目

code:

public class Solution {
    public int lengthOfLIS(int[] nums) {
        
        if(nums.length == 0)
            return 0;
        int max = 1;
        int[] dp = new int[nums.length];
        Arrays.fill(dp,1);
        for(int i=1; i<nums.length; i++)
        {
            for(int j=0; j<i; j++)
            {
                if(nums[i]> nums[j])
                {
                    if(dp[j]+1>dp[i])
                        dp[i] = dp[j]+1;
                }
            }
            if(max<dp[i])
                max = dp[i];
        }
        return max;
    }
}

你可能感兴趣的:([LeetCode]Longest Increasing Subsequence)